/*=================================================
          Nodes Header 
=================================================*/
enum	{ ID = 257, NUM, EOLN, BAD, UNIT, GVAR, USER, FUNC, FUNC2, FUNC3  };
typedef	int	Token;

/***************************************************************
[ NX ] Node 
[NX] Ȃ 
[   @\   ] eh֐̐lE֐ eval() ̉z֐𑕔
[  o  ] Err       Eʏ펞 = TRUE, G[ = FALSE
             error     EG[N`FbN
***************************************************************/
class	Node
{
	protected:
		BOOL	Err;
	public:
		Node() { Err = TRUE; }
		BOOL	error(){ return Err; }
		virtual	~Node()	{}
		virtual	complx	eval()	{ error();	return	0;}
};

/***************************************************************
[ NX ] Binop 
[NX] Node 
[   @\   ] evZ̃obt@ left, right ̑A蓖Ăꂽ
             ̉B
[  o  ] left      Eӕi[p|C^
             right     EEӕi[p|C^
***************************************************************/
class	Binop	:	public	Node
{
	public:
		Binop( Node	*l, Node	*r)	{left = l;	right = r; }
		~Binop(){	delete left;	delete right;	}
	protected:
		Node	*left,	*right;
};

/***************************************************************
[ NX ] Plus 
[NX] Binop <- Node 
[   @\   ] Z
[  o  ] eval()    EvZʂԂ
***************************************************************/
class	Plus	:	public	Binop
{
	public:
		Plus(Node	*l, Node	*r)	:	Binop(l,r)	{}
		complx	eval()
		{
			complx	l = left->eval();
			return l + right->eval();
		}
};

/***************************************************************
[ NX ] Minus 
[NX] Binop <- Node 
[   @\   ] Z
[  o  ] eval()    EvZʂԂ
***************************************************************/
class	Minus	:	public	Binop
{
	public:
		Minus(Node	*l, Node	*r)	:	Binop(l,r)	{}
		complx	eval()
		{
			complx	l = left->eval();
			return l - right->eval();
		}
};

/***************************************************************
[ NX ] Times 
[NX] Binop <- Node 
[   @\   ] Z
[  o  ] eval()    EvZʂԂ
***************************************************************/
class	Times	:	public	Binop
{
	public:
		Times(Node	*l, Node	*r)	:	Binop(l,r)	{}
		complx	eval()
		{
			complx	l = left->eval();
			return l * right->eval();
		}
};

/***************************************************************
[ NX ] Div 
[NX] Binop <- Node 
[   @\   ] Z
[  o  ] eval()    EvZʂԂ
***************************************************************/
class	Div	:	public	Binop
{
	public:
		Div(Node	*l, Node	*r)	:	Binop(l,r)
		{
			if( (r->eval()).Real() == 0 && (r->eval()).Image() == 0 )
				Err = FALSE;	// 0ŏZꍇ 
		}
		complx	eval()
		{
			complx	l = left->eval();
			return l / right->eval();
		}
};

/***************************************************************
[ NX ] Uminus 
[NX] Binop <- Node 
[   @\   ] i[j
[  o  ] eval()    EvZʂԂ
***************************************************************/
class	Uminus	:	public	Node
{
	private:
		Node	*operand;
	public:
		Uminus(Node	*o)	{operand = o;}
		~Uminus()	{delete operand;}
		complx	eval()	{return -operand->eval();}
};

/***************************************************************
[ NX ] Num 
[NX] Node 
[   @\   ] i[
[  o  ] eval()    ElԂ
***************************************************************/
class	Num	:	public	Node
{
	private:
		complx	value;
	public:
		Num(complx	v)	{value = v;}
		complx	eval()	{return value;}
};

/***************************************************************
[ NX ] Nament 
[NX] Ȃ 
[   @\   ] ϐi[pBXgŊǗB
[  o  ] name   Eϐ
             value  El
			 naxt   EXg\zp
			 attrib E i GVAR = ϐA UNIT = 萔B֎~ j
***************************************************************/
class	Id;
class	Nament
{
	private:
		CString	name;
		complx	value;
		CString	info;
		Nament	*next;
		int		attrib;

		Nament( char  *nm, Nament	*n, int atr = GVAR, complx val = 0, char* inf = NULL )
		{
			name = nm;
			value = val;
			attrib = atr;
			next = n;
			if( inf )info = inf; else info = "[U[ϐ";
		}
		~Nament(){ 	if( next != NULL )delete next; }

	friend	Id;
};

/***************************************************************
		ϐpO[oϐ
***************************************************************/
#ifdef	_ID_INIT
	Nament*	ID_Symtab = NULL;	// ϐXg̐擪|C^
#else
	extern	Nament*	ID_Symtab;
#endif

/***************************************************************
[ NX ] Id 
[NX] Node 
[   @\   ] ϐXg̍\zAϐ̊Ǘ
[  o  ] set        Eϐɒl
             eval       Eϐ̒lԂB
			 GetAttrib  Eϐ̏E
             entry      Eϐi[IuWFNg(Nament)̃|C^
             --- class Nament ̃oQƉ --- 
***************************************************************/
class	Id	:	public	Node
{
	public:
		Id(){}
		Id( char *nm ) { entry = look( nm ); }
		complx	set( complx	i )	{ return entry->value = i; }
		complx	eval()	{ return entry->value; }
		int		GetAttrib(){ return entry->attrib; }
		CString	GetGvarInfo(){ return entry->info; };

		void	DeleteList(){ if( ID_Symtab != NULL ){ delete ID_Symtab; ID_Symtab = NULL; } }
		BOOL	GetGvarData( int index, CString* name, complx* value, CString* info = NULL   );
		BOOL	DeleteGvar( CString GvarName );
	private:
		Nament* entry;
	protected:
		Nament	*look(char	*);
		void	MakeDefault( Nament* &symtab );
};

/***************************************************************
[ NX ] Func 
[NX] Id <- Node 
[   @\   ] ֐̎s
[  o  ] value      EvZʂ̊i[
             eval       EvZʂԂB
***************************************************************/
class	Func	:	public	Id
{
	private:
		complx	value; 
	public:
		Func( int index, Node* Paran1 );
		Func( int index, Node* Paran1, Node* Param2 );
		complx	eval()	{ return value; }
};


/***************************************************************
[ NX ] Assign 
[NX] Binop <- Node 
[   @\   ] ϐւ̒l̑A 萔ւ̑֎~`FbN
[  o  ] eval    EԂB
***************************************************************/
class	Assign	:	public	Binop
{
	public:
		Assign(Id	*t, Node	*e)	:	Binop(t, e)
		{ if( t->GetAttrib() != GVAR )Err = FALSE; }
		complx	eval()
		{ return	((Id	*)left)->set(right->eval()); }
};
